# The following variables need to be set on GitLab project
# variables:
#   SONAR_HOST_URL: "https://sonarqube.tools.simpl-europe.eu"
#   SONAR_TOKEN: "" #Goto https://sonarqube.tools.simpl-europe.eu/account/security for creating a Global Token
# 
# Assumptions:
# * Import GitLab project into SonarQube. Do it on https://sonarqube.tools.simpl-europe.eu/projects/create?mode=gitlab
# * Get <Project Key> on SonarQube. Enter SonarQube Project. Go to Project Information. Copy <Project Key> value
# * Set $SONAR_PROJECT_ID=<Project Key>, as a GitLab Project Variable

.sonar-base:
  stage: quality-testing
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]

  cache:
    - key: "sonar-$CI_COMMIT_REF_SLUG"
      paths:
        - .sonar/cache
  # Sonar related variables
  # See also https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/pull-request-analysis/setting-up-the-pull-request-analysis/
  # and https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/analysis-parameters/
  before_script:
    - !reference [.set-version-vars, before_script] #include here that script code
    - |
      add_sonar_prop() {
        local settingName=$1
        local settingValue=$2

        if [ ! -f "sonar-project.properties" ]; then
            touch "sonar-project.properties"
            echo "File sonar-project.properties created."
        fi

        # Add prop only if not already present
        if grep -q "^${settingName}=" "sonar-project.properties"; then
            echo "Setting ${settingName} skipped."
        else
            echo "${settingName}=${settingValue}" >> "sonar-project.properties"
            echo "Setting ${settingName} added."
        fi
      }
    - echo "" >> "sonar-project.properties"
    - if [ "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME" != "" ]; then 
    -   add_sonar_prop "sonar.pullrequest.key" $CI_MERGE_REQUEST_ID
    -   add_sonar_prop "sonar.pullrequest.branch" $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME
    -   add_sonar_prop "sonar.pullrequest.base" $CI_MERGE_REQUEST_TARGET_BRANCH_NAME
    - else
    -   add_sonar_prop "sonar.branch.name" $CI_COMMIT_BRANCH
    - fi
    - add_sonar_prop "sonar.projectName" $FORTIFY_PRJ
    - add_sonar_prop "sonar.projectVersion" $PROJECT_VERSION_NUMBER
    - add_sonar_prop "sonar.projectKey" $CI_PROJECT_PATH_SLUG-$CI_PROJECT_ID

  variables:
    # Sonar Scanner docs: https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner/
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
    SONAR_OPTS_BASE: >-
      -Dsonar.qualitygate.wait=true
      -Dsonar.token=$SONAR_TOKEN
     

echo-sonarqube-vars-job:
  extends: 
    - .sonar-base
  script:
    - echo "SIMPL Pipeline sonar Job"
    - echo "SONAR_HOST_URL=$SONAR_HOST_URL"
    - echo "SONAR_TOKEN=$SONAR_TOKEN"
    - echo "SONAR_PROJECT_ID=$SONAR_PROJECT_ID"
    - echo "CI_COMMIT_TAG=$CI_COMMIT_TAG"
    - echo "CI_PIPELINE_SOURCE=$CI_PIPELINE_SOURCE"
    - echo "CI_MERGE_REQUEST_TARGET_BRANCH_NAME=$CI_MERGE_REQUEST_TARGET_BRANCH_NAME"
    - cat sonar-project.properties
    
  rules:
    - if: $DEBUG =~ /sonar/


